package org.bouncycastle.asn1;

import java.io.*;

/**
 * DER PrintableString object.
 */
public class DERPrintableString
    extends DERObject
    implements DERString
{
    String  string;

    /**
     * basic constructor - byte encoded string.
     */
    public DERPrintableString(
        byte[]   string)
    {
        this.string = new String(string);
    }

    /**
     * basic constructor
     */
    public DERPrintableString(
        String   string)
    {
        this.string = string;
    }

    public String getString()
    {
        return string;
    }

    void encode(
        DEROutputStream  out)
        throws IOException
    {
        out.writeEncoded(PRINTABLE_STRING, string.getBytes());
    }
}
