package org.bouncycastle.asn1;

import java.io.*;

/**
 * DER Set object, for a constructed BER encoding.
 */
public class DERSet
    extends DERObject
{
    DERObject      sequence;

    /**
     * @param sequence the sequence making up the set
     */
    public DERSet(
        DERObject   sequence)
    {
        this.sequence = sequence;
    }

    public DERObject getSequence()
    {
        return sequence;
    }

    void encode(
        DEROutputStream  out)
        throws IOException
    {
        ByteArrayOutputStream   bOut = new ByteArrayOutputStream();
        DEROutputStream         dOut = new DEROutputStream(bOut);

        dOut.writeObject(sequence);
        dOut.close();

        out.writeEncoded(CONSTRUCTED | SET, bOut.toByteArray());
    }
}
