import java.io.*;
import java.util.Vector;
import java.util.Enumeration;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;

import nanoxml.*;

public class NanoNewsreader extends MIDlet implements CommandListener {

    static final String URL = "http://newsforge.com/newsforge.xml";
    static final String TITLE = "NewsForge";
	
    Vector descriptions = new Vector ();
    List newsList = new List (TITLE, Choice.IMPLICIT);
    TextBox textBox = new TextBox ("", "", 256, TextField.ANY);
    Display display;

    Command backCmd = new Command ("Back", Command.BACK, 0);

    public void startApp () {
	display = Display.getDisplay (this);
	display.setCurrent (newsList);
	newsList.setCommandListener (this);
	textBox.setCommandListener (this);
	textBox.addCommand (backCmd);
	if (descriptions.size () == 0) 
	    readNews ();
    }


    public void readNews () {
	try {
	    HttpConnection httpConnection = 
		(HttpConnection) Connector.open (URL);
	    
	    kXMLElement xml = new kXMLElement ();
	    xml.parseFromReader (new InputStreamReader (httpConnection.openInputStream ()));
	    
	    for (Enumeration e = xml.enumerateChildren (); 
		 e.hasMoreElements ();) 
		readStory ((kXMLElement) e.nextElement ());
	}
	catch (IOException e) {
	    newsList.append ("Error",null);
	    descriptions.addElement (e.toString ());
	}
    }
	
    
    /** Read a story and append it to the list */
    
    public void readStory (kXMLElement story) {
	String title = null;
	String description = null;
	for (Enumeration e = story.enumerateChildren (); 
	     e.hasMoreElements (); ) {
	    
	    kXMLElement field = (kXMLElement) e.nextElement ();
	    
	    if (field.getTagName ().equals ("title"))
		title = field.getContents ();
	    else if (field.getTagName ().equals ("description"))
		description = field.getContents ();
	}
	
	if (title != null) { 
	    descriptions.addElement (description != null ? description : title);
	    newsList.append (title, null);
	}
    }



    public void pauseApp () {
    }



    public void commandAction (Command c, Displayable d) {

	if (c == List.SELECT_COMMAND) {
	    
	    String text = (String) descriptions.elementAt 
		(newsList.getSelectedIndex ());
		 
	    if (textBox.getMaxSize () < text.length ()) 
		textBox.setMaxSize (text.length ());
	    
	    textBox.setString (text);
	    display.setCurrent (textBox);
	}
	else if (c == backCmd)
	    display.setCurrent (newsList);
    }
 

    public void destroyApp (boolean really) {
    }

    public static void main (String [] argv) {
	new NanoNewsreader ().startApp ();
    }
}



