import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

class StopWatchCanvas extends Canvas implements Runnable {

    int degree = 360;
    long startTime;
    int seconds;
    Display display;

    StopWatchCanvas (Display display, int seconds) {

	this.display = display;
	this.seconds = seconds;

        startTime = System.currentTimeMillis ();	
    }
    

    public void paint (Graphics g) {
	
	g.setGrayScale (255);
	g.fillRect (0, 0, getWidth (), getHeight ());

	if (degree > 0) {
	    g.setColor (255, 0, 0);
	    g.fillArc (0,0, getWidth (), getHeight (), 90, degree);
	    
	    display.callSerially (this);
	}

	g.setGrayScale (0);
	g.drawArc (0, 0, getWidth ()-1, getHeight ()-1, 0, 360);
    }

	
    public void run () {
	    
	int permille = (int) ((System.currentTimeMillis () - startTime) / seconds); 
	
	degree = 360 - (permille * 360) / 1000; 
	
	repaint ();
    }
}


public class StopWatch extends MIDlet {


    public void startApp () {
	Display display = Display.getDisplay (this);
	display.setCurrent (new StopWatchCanvas (display, 10)); 
    }


    public void pauseApp () {
    }
    
    public void destroyApp (boolean forced) {
    }

}
