import java.awt.*;
import java.awt.event.*;
import java.util.Random;
import javax.microedition.midlet.*;


public class GhostWriter2 extends MIDlet implements ActionListener {

    List logList = new List ();
    Frame frame = new Frame ("The Monkeys type....");
    Button exitButton = new Button ("exit");
    Button generateButton = new Button ("generate");
    Button logButton = new Button ("log");
    TextField generatedField = new TextField ();
    Choice monkeyChoice = new Choice ();
    Random random = new Random ();

    
    public GhostWriter2 () {

        monkeyChoice.add ("Dumbo");
        monkeyChoice.add ("Sally");

        Panel labelPanel = new Panel (new GridLayout (0, 1));
        labelPanel.add (new Label ("Monkey:"));
        labelPanel.add (new Label ("Generated:"));
        
        Panel fieldPanel = new Panel (new GridLayout (0, 1));
        fieldPanel.add (monkeyChoice);
        fieldPanel.add (generatedField);
                        
        Panel controlPanel = new Panel (new BorderLayout ());
        controlPanel.add (labelPanel, BorderLayout.WEST);
        controlPanel.add (fieldPanel, BorderLayout.CENTER);

        Panel buttonPanel = new Panel (new FlowLayout ());
        buttonPanel.add (exitButton);
        buttonPanel.add (generateButton);
        buttonPanel.add (logButton);

        exitButton.addActionListener (this);
        generateButton.addActionListener (this);
        logButton.addActionListener (this);
        
        frame.add (controlPanel, BorderLayout.NORTH);
        frame.add (logList, BorderLayout.CENTER);
        frame.add (buttonPanel, BorderLayout.SOUTH);
        frame.pack ();

        frame.addWindowListener (new WindowAdapter () {
                public void windowClosing (WindowEvent ev) {
                    notifyDestroyed ();
                }
            });
    }

    
    public void startApp () {
        frame.show ();
    }

    
    public void actionPerformed (ActionEvent ev) {

        if (ev.getSource () == exitButton) 
            notifyDestroyed ();
        else if (ev.getSource () == generateButton) 
            generateNewSentence ();
        else if (ev.getSource () == logButton) 
            logList.add (generatedField.getText ());
    }


    public void generateNewSentence () {
        StringBuffer buf = new StringBuffer ();

        int baseChar = monkeyChoice.getSelectedItem ().equals ("Dumbo") 
            ? 'A' : 'a';

        for (int i = 0; i < 60; i++) {
            char c = (char) (baseChar + (random.nextInt () & 31));
            if (Character.toUpperCase (c) > (baseChar+26)) c = ' ';
            buf.append (c);
        }

        generatedField.setText (buf.toString ());
    }


    public void pauseApp() {
    }


    public void destroyApp (boolean forced) {
    }
}
