import java.awt.*;
import java.awt.event.*;
import javax.microedition.rms.*;
import javax.microedition.midlet.*;

public class RmsDemoPdap extends MIDlet implements ActionListener {

    Frame frame = new Frame ();
    TextArea textArea = new TextArea ();

    int currentId;
    RecordStore diary;

    Button buttonPrev =new Button ("Prev");
    Button buttonNext =new Button ("Next");
    Button buttonNew =new Button ("New");

    public RmsDemoPdap (){
        try {
            diary = RecordStore.openRecordStore ("diary",true);
            String text = loadEntry (diary.getNumRecords ());
            textArea.setText (text);
            frame.setTitle ("Diary - Day " + currentId);
        }
        catch (RecordStoreException e){
            throw new RuntimeException ("Cannot open diary; reason:"+e);
        }
        
        frame.add ("Center", textArea);
        Panel buttons = new Panel ();

        buttons.add (buttonPrev);
        buttons.add (buttonNext);
        buttons.add (buttonNew);
        buttonPrev.addActionListener (this);
        buttonNext.addActionListener (this);
        buttonNew.addActionListener (this);

        frame.add ("South",buttons);
        frame.pack ();
        frame.addWindowListener (new WindowAdapter (){
            public void windowClosing (WindowEvent ev){
                destroyApp (true);
                notifyDestroyed ();
            }
        });
    }

    public String loadEntry (int newId)throws RecordStoreException {
        if (newId < 1 || newId > diary.getNumRecords ()) {
            byte [] data = "".getBytes ();
            currentId = diary.addRecord (data, 0, data.length);
        }
        else
            currentId =newId;

        return new String (diary.getRecord (currentId));
    }

    public void saveEntry (String entry) throws RecordStoreException {
       byte [] data = entry.getBytes ();
       diary.setRecord (currentId, data, 0, data.length);
    }

    public void startApp () {
        frame.show ();
    }

    public void destroyApp (boolean unconditional) {
        try {
            saveEntry (textArea.getText ());
            diary.closeRecordStore ();
        }
        catch (RecordStoreException e) {
            throw new RuntimeException ("Cannot close Diary; reason:"+e);
         }
    }

    public void pauseApp () {
    }

    public void actionPerformed (ActionEvent ev) {
        try {
            saveEntry (textArea.getText ());

            if (ev.getSource () == buttonNext && currentId < diary.getNumRecords ())
                textArea.setText (loadEntry (currentId+1));
            else if (ev.getSource () == buttonPrev && currentId > 1)
                textArea.setText (loadEntry (currentId-1));
            else if (ev.getSource () == buttonNew)
                textArea.setText (loadEntry (diary.getNumRecords ()+1));
        
            frame.setTitle ("Diary - Day " + currentId);
        }
        catch (RecordStoreException e) {
           throw new RuntimeException ("Cannot perform; reason:"+e);
        }
    }
}
