import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

import javax.microedition.midlet.*;
import javax.microedition.rms.*;

public class BloodSugarPdap extends MIDlet implements ActionListener {

    Frame frame = new Frame ();
    LogStorage log;
    DayLog dayLog;

    Button setButton = new Button ("set");
    Button removeButton = new Button ("remove");
    Button dateButton = new Button ("date...");

    TextField timeField = new TextField ();
    TextField valueField = new TextField ();

    Chart chart = new Chart ();

    class Chart extends Canvas {

        public void paint (Graphics g) {

            FontMetrics fm = g.getFontMetrics ();
            Dimension size = getSize ();
            
            int cw = fm.stringWidth ("0");
            int lw = 3*cw;
            int lh = fm.getHeight ();

            int w = size.width - lw;
            int h = size.height - lh;

            g.drawString (""+DayLog.MAX_VALUE, 0, fm.getAscent ());
            g.drawString (""+DayLog.MIN_VALUE, cw, h - fm.getDescent ());

            g.translate (lw, h);

            g.drawString (""+(DayLog.MIN_TIME/60), 0, fm.getAscent ());
            g.drawString (""+(DayLog.MAX_TIME+DayLog.MIN_TIME)/120, 
                          w/2-cw, fm.getAscent ());
            g.drawString (""+(DayLog.MAX_TIME/60), w-2*cw, fm.getAscent ());

            g.drawLine (-2, 0, w + 2, 0);
            g.drawLine (0, 2, 0, - (h + 2));

            int mnb = DayLog.getY (DayLog.MIN_BORDER, h);
            int mxb = DayLog.getY (DayLog.MAX_BORDER, h);

            g.setColor (Color.red);
            g.drawLine (-2, mnb, w + 2, mnb);
            g.drawLine (-2, mxb, w + 2, mxb);

            g.setColor (Color.blue);
            
            int[] x = dayLog.getXPoints (w);
            int[] y = dayLog.getYPoints (h);
            
            for (int i = 0; i < dayLog.getCount (); i++) 
                g.drawOval (x [i]-1, y[i]-1, 2, 2);
            
            g.drawPolyline (x, y, dayLog.getCount ());
        }
        
        public Dimension getPreferredSize () {
            return new Dimension (200, 200);
        }
    }



    public BloodSugarPdap () throws RecordStoreException, IOException {
        log = new LogStorage ();
        dayLog = log.getDayLog (LogStorage.dateToInt (new Date ()));
        frame.setTitle (dayLog.getTitle ());

        Panel inputPane = new Panel (new BorderLayout ());

        Panel labelPane = new Panel (new GridLayout (0,1));
        labelPane.add (new Label ("Time (hh:mm)"));
        labelPane.add (new Label ("Value (mg/dl)"));
        inputPane.add ("West", labelPane);

        Panel fieldPane = new Panel (new GridLayout (0,1));
        fieldPane.add (timeField);
        fieldPane.add (valueField);
        inputPane.add ("Center", fieldPane);

        Panel buttonPane = new Panel ();
        buttonPane.add (setButton);
        setButton.addActionListener (this);
        buttonPane.add (removeButton);
        removeButton.addActionListener (this);
        buttonPane.add (dateButton);
        dateButton.addActionListener (this);
        inputPane.add ("South", buttonPane);

        frame.add ("Center", chart);
        frame.add ("South", inputPane);
        frame.pack ();

        frame.addWindowListener (new WindowAdapter () {
                public void windowClosing (WindowEvent ev) {
                    frame.dispose ();
                    notifyDestroyed ();
                } 
            });
    }

    public void startApp () {
        frame.show ();
    }

    
    public void pauseApp () {
    }


    public void destroyApp (boolean conditional) {
        frame.dispose ();
    }
    
    
    public void actionPerformed (ActionEvent action) {
        try {
            if (action.getSource () == setButton) {
                dayLog.set (DayLog.parseTime (timeField.getText ()), 
                            Integer.parseInt (valueField.getText ()));
                
                log.storeDayLog (dayLog);
            }
            else if (action.getSource () == removeButton) {
                dayLog.remove (DayLog.parseTime (timeField.getText ()));
                log.storeDayLog (dayLog);
            }
            else if (action.getSource () == dateButton) {
                Runtime.getRuntime().gc();

                dayLog = log.getDayLog 
                    (LogStorage.dateToInt 
                     (new DateDialog (frame).getDate (new Date ())));

              frame.setTitle (dayLog.getTitle ());
            }
        }
        catch (Exception e) {
            throw new RuntimeException (""+e);
        }

        chart.repaint ();
    }
} 

